## visp 3.7.0

=== CMakeLists.txt ===
#############################################################################
#
# ViSP, open source Visual Servoing Platform software.
# Copyright (C) 2005 - 2024 by Inria. All rights reserved.
#
# This software is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# See the file LICENSE.txt at the root directory of this source
# distribution for additional information about the GNU GPL.
#
# For using ViSP with software that can not be combined with the GNU
# GPL, please contact Inria about acquiring a ViSP Professional
# Edition License.
#
# See https://visp.inria.fr for more information.
#
# This software was developed at:
# Inria Rennes - Bretagne Atlantique
# Campus Universitaire de Beaulieu
# 35042 Rennes Cedex
# France
#
# If you have questions regarding the use of this file, please contact
# Inria at visp@inria.fr
#
# This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
# WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#
# Description:
# ViSP overall configuration file. Detect third party libraries (X11, GTK, ...)
#
#############################################################################

# Detect crosscompiling; need to be before project(VISP) to work
if(NOT CMAKE_TOOLCHAIN_FILE)
  # Modify default install prefix
  if(WIN32)
    set(CMAKE_INSTALL_PREFIX "${CMAKE_BINARY_DIR}/install" CACHE PATH "Installation Directory")
  endif()
else(NOT CMAKE_TOOLCHAIN_FILE)
  #Android: set output folder to ${CMAKE_BINARY_DIR}
  set(LIBRARY_OUTPUT_PATH_ROOT ${CMAKE_BINARY_DIR} CACHE PATH "root for library output, set this to change where android libs are compiled to" )
  # Crosscompiling
  set(CMAKE_INSTALL_PREFIX "${CMAKE_BINARY_DIR}/install" CACHE PATH "Installation Directory")
endif()

if(CMAKE_SYSTEM_NAME MATCHES WindowsPhone OR CMAKE_SYSTEM_NAME MATCHES WindowsStore)
  set(WINRT TRUE)
endif(CMAKE_SYSTEM_NAME MATCHES WindowsPhone OR CMAKE_SYSTEM_NAME MATCHES WindowsStore)

if(WINRT)
  add_definitions(-DWINRT)

  if(CMAKE_SYSTEM_NAME MATCHES WindowsPhone)
    set(WINRT_PHONE TRUE)
    add_definitions(-DWINRT_PHONE)
  elseif(CMAKE_SYSTEM_NAME MATCHES WindowsStore)
    set(WINRT_STORE TRUE)
    add_definitions(-DWINRT_STORE)
  endif()

  if(CMAKE_SYSTEM_VERSION MATCHES 10 OR CMAKE_SYSTEM_VERSION MATCHES 10.0)
    set(WINRT_10 TRUE)
    add_definitions(-DWINRT_10)
  elseif(CMAKE_SYSTEM_VERSION MATCHES 8.1)
    set(WINRT_8_1 TRUE)
    add_definitions(-DWINRT_8_1)
  elseif(CMAKE_SYSTEM_VERSION MATCHES 8.0)
    set(WINRT_8_0 TRUE)
    add_definitions(-DWINRT_8_0)
  endif()
endif()

# By default set release configuration
if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "Release" CACHE STRING "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel." FORCE)
endif()

cmake_minimum_required(VERSION 3.10) # needs to be before project() for policy CMP0025

# Detect if the toolchain is for Aldebaran naoqi
if(CMAKE_TOOLCHAIN_FILE AND I_AM_A_ROBOT)
  include(platforms/naoqi/cmake/extra.cmake)
endif()

if(POLICY CMP0020)
  cmake_policy(SET CMP0020 NEW) # For UsTK: Qt5
endif()
if(POLICY CMP0022)
  cmake_policy(SET CMP0022 NEW) # Due to sensor ATIDAQ_LIBRARIES
endif()
if(POLICY CMP0025)
  cmake_policy(SET CMP0025 NEW) # To set compiler id for Apple Clang to AppleClang instead of Clang. Required to detect OpenMP support on MacOS
endif()
if(POLICY CMP0053)
  cmake_policy(SET CMP0053 NEW) # For UsTK: VTK and Qt5
endif()
if(POLICY CMP0054)
  cmake_policy(SET CMP0054 NEW) # To turn off a warning in native FindOpenMP with cmake 3.9.2
endif()
if(POLICY CMP0068)
  cmake_policy(SET CMP0068 NEW)  # CMake 3.9+: `RPATH` settings on macOS do not affect `install_name`.
endif()
if(POLICY CMP0072)
  cmake_policy(SET CMP0072 NEW) # To use legacy GL library with FindOpenGL and cmake 3.12.0
endif()
if(POLICY CMP0074)
  cmake_policy(SET CMP0074 NEW) # For PCL_ROOT usage and cmake 3.12.0 when PCL 1.9.1 all in one is used on Windows
endif()
if(POLICY CMP0075)
  cmake_policy(SET CMP0075 NEW) # For check_include_file and cmake 3.12.0
endif()
if(POLICY CMP0146)
  cmake_policy(SET CMP0146 OLD) # The ``FindCUDA`` module deprecated since CMake 3.10
endif()

if(APPLE)
  # Fix following errors for libpng and libjpeg detection:
  # - Application built with libpng-1.4.12 but running with 1.6.37,
  # - Wrong JPEG library version: library is 90, caller expects 80.
  # The reason is that headers were found in /Library/Frameworks/Mono.framework/Headers
  # while libraries in /usr/local/lib
  set(CMAKE_FIND_FRAMEWORK LAST)
endif()

project(VISP C CXX)

list(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake")

include(cmake/VISPUtils.cmake)
include(cmake/VISPDetectCXXStandard.cmake) # Set cxx standard to 17 by default

#-----------------------------------------------------------------------------
# VISP version number.  An even minor number corresponds to releases.
set(VISP_VERSION_MAJOR "3")
set(VISP_VERSION_MINOR "7")
set(VISP_VERSION_PATCH "0")
set(VISP_VERSION "${VISP_VERSION_MAJOR}.${VISP_VERSION_MINOR}.${VISP_VERSION_PATCH}")
set(VISP_SOVERSION "${VISP_VERSION_MAJOR}.${VISP_VERSION_MINOR}")
# Package revision number
set(VISP_REVISION "1")

# Try to locate visp-images and, if it exists, its version
vp_find_dataset(VISP_DATASET_FOUND VISP_DATASET_LOCATION
                VISP_DATASET_VERSION
                VISP_DATASET_VERSION_MAJOR
                VISP_DATASET_VERSION_MINOR
                VISP_DATASET_VERSION_PATCH)

#-----------------------------------------------------------------------------
# TO BE CHECKED BEFORE NEXT RELEASE
#
# Remove following 3 next lines and check if pcl produces a CMP0144 complain around CMake variable FLANN_ROOT set to /opt/homebrew
if(NOT DEFINED CMAKE_SUPPRESS_DEVELOPER_WARNINGS)
  set(CMAKE_SUPPRESS_DEVELOPER_WARNINGS 1 CACHE INTERNAL "No dev warnings")
endif()
#-----------------------------------------------------------------------------

find_file(GNU_INSTALL_DIRS_FROM_CMAKE NAMES GNUInstallDirs.cmake PATHS ${CMAKE_ROOT}/Modules)
mark_as_advanced(GNU_INSTALL_DIRS_FROM_CMAKE)
if(GNU_INSTALL_DIRS_FROM_CMAKE)
  include(${CMAKE_ROOT}/Modules/GNUInstallDirs.cmake)
else()
  include(cmake/GNUInstallDirs.cmake)
endif()

#----------------------------------------------------------------------
# Tool specific
#----------------------------------------------------------------------
# PCL tools
include(cmake/PCLTools.cmake)
# Eigen3 tools
include(cmake/Eigen3Tools.cmake)

#----------------------------------------------------------------------
# Platform specific
#----------------------------------------------------------------------
include(cmake/VISPDetectPlatform.cmake)

# Where to install the library and headers
if(ANDROID)
  # Where to build modules
  set(LIBRARY_OUTPUT_PATH                 "${VISP_BINARY_DIR}/lib/${ANDROID_NDK_ABI_NAME}")
  # Where to build internal 3rdparties
  vp_update(VISP_3P_LIBRARY_OUTPUT_PATH   "${VISP_BINARY_DIR}/3rdparty/lib/${ANDROID_NDK_ABI_NAME}")

  vp_update(VISP_INSTALL_BINARIES_PREFIX "sdk/native/")
  # set binary path
  vp_update(VISP_BIN_INSTALL_PATH         "sdk/native/bin/${ANDROID_NDK_ABI_NAME}")

  # set samples path
  vp_update(VISP_SAMPLES_BIN_INSTALL_PATH "sdk/native/samples/${ANDROID_NDK_ABI_NAME}")

  vp_update(VISP_LIB_INSTALL_PATH         "sdk/native/libs/${ANDROID_NDK_ABI_NAME}")
  vp_update(VISP_LIB_ARCHIVE_INSTALL_PATH "sdk/native/staticlibs/${ANDROID_NDK_ABI_NAME}")
  vp_update(VISP_3P_LIB_INSTALL_PATH      "sdk/native/3rdparty/libs/${ANDROID_NDK_ABI_NAME}")
  vp_update(VISP_CONFIG_INSTALL_PATH      "sdk/native/jni")
  vp_update(VISP_INC_INSTALL_PATH         "sdk/native/jni/include")
  vp_update(VISP_SAMPLES_SRC_INSTALL_PATH "samples/native")
  vp_update(VISP_INSTALL_DATAROOTDIR      "sdk/etc")

elseif(WIN32 AND CMAKE_HOST_SYSTEM_NAME MATCHES Windows)
  # Where to build modules
  set(LIBRARY_OUTPUT_PATH         "${VISP_BINARY_DIR}/lib")
  # Where to build internal 3rdparties
  vp_update(VISP_3P_LIBRARY_OUTPUT_PATH "${VISP_BINARY_DIR}/3rdparty/lib${LIB_SUFFIX}")

  if(DEFINED VISP_RUNTIME AND DEFINED VISP_ARCH)
    vp_update(VISP_INSTALL_BINARIES_PREFIX "${VISP_ARCH}/${VISP_RUNTIME}/")
  else()
    message(STATUS "Can't detect runtime and/or arch")
    vp_update(VISP_INSTALL_BINARIES_PREFIX "")
  endif()

  if(VISP_STATIC)
    vp_update(VISP_LIB_INSTALL_PATH "${VISP_INSTALL_BINARIES_PREFIX}staticlib${LIB_SUFFIX}")
  else()
    vp_update(VISP_LIB_INSTALL_PATH "${VISP_INSTALL_BINARIES_PREFIX}lib${LIB_SUFFIX}")
  endif()
  vp_update(VISP_3P_LIB_INSTALL_PATH      "${VISP_INSTALL_BINARIES_PREFIX}staticlib${LIB_SUFFIX}")
  vp_update(VISP_SAMPLES_SRC_INSTALL_PATH samples/native)
  vp_update(VISP_JAR_INSTALL_PATH         java)
  vp_update(VISP_INC_INSTALL_PATH         "${CMAKE_INSTALL_INCLUDEDIR}")
  vp_update(VISP_BIN_INSTALL_PATH         "${VISP_INSTALL_BINARIES_PREFIX}bin")
  vp_update(VISP_INSTALL_DATAROOTDIR      "${CMAKE_INSTALL_DATAROOTDIR}/visp-${VISP_VERSION}")
  vp_update(VISP_CONFIG_INSTALL_PATH      ".")

else() # UNIX
  # Where to build modules
  set(LIBRARY_OUTPUT_PATH         "${VISP_BINARY_DIR}/lib")
  # Where to build internal 3rdparties
  vp_update(VISP_3P_LIBRARY_OUTPUT_PATH "${VISP_BINARY_DIR}/3rdparty/lib${LIB_SUFFIX}")

  vp_update(VISP_INSTALL_BINARIES_PREFIX "")

  #----------------------------------------------------------------------
  # Multi-arch option that should be enable for debian packaging
  #----------------------------------------------------------------------
  VP_OPTION(ENABLE_MULTIARCH  "" "" "Enable multi-arch support"  "" OFF IF (NOT APPLE))

  # The location where includes and libraries will be installed
  if(ENABLE_MULTIARCH)
    # The 2 following lines should be used to enable multi-arch support.
    vp_update(VISP_INC_INSTALL_PATH       "${CMAKE_INSTALL_INCLUDEDIR}/${CMAKE_LIBRARY_ARCHITECTURE}")
    vp_update(VISP_LIB_INSTALL_PATH       "${CMAKE_INSTALL_LIBDIR}/${CMAKE_LIBRARY_ARCHITECTURE}")
  else()
    # catkin doesn't support multi-arch; use rather the next 2 lines
    vp_update(VISP_INC_INSTALL_PATH       "${CMAKE_INSTALL_INCLUDEDIR}")
    vp_update(VISP_LIB_INSTALL_PATH       "${CMAKE_INSTALL_LIBDIR}")
  endif()
  vp_update(VISP_BIN_INSTALL_PATH         "${CMAKE_INSTALL_BINDIR}")
  vp_update(VISP_INSTALL_DATAROOTDIR      "${CMAKE_INSTALL_DATAROOTDIR}/visp-${VISP_VERSION}")
  vp_update(VISP_3P_LIB_INSTALL_PATH      "${VISP_LIB_INSTALL_PATH}/visp/3rdparty")
  vp_update(VISP_SAMPLES_SRC_INSTALL_PATH "${VISP_INSTALL_DATAROOTDIR}/samples")
  vp_update(VISP_JAR_INSTALL_PATH         "${VISP_INSTALL_DATAROOTDIR}/java")
  vp_update(VISP_CONFIG_INSTALL_PATH      "${VISP_LIB_INSTALL_PATH}/cmake/visp")
endif()

# the include directory we depend on for the build
set(VISP_INCLUDE_DIR ${VISP_BINARY_DIR}/${VISP_INC_INSTALL_PATH})
set(VISP_DOC_DIR "${VISP_BINARY_DIR}/doc")

# The location where includes and libraries will be build
set(BINARY_OUTPUT_PATH ${VISP_BINARY_DIR}/${VISP_BIN_INSTALL_PATH})

if(WIN32)
  # Postfix of .lib and .dll
  set(VISP_DEBUG_POSTFIX "d")
  set(VISP_DLLVERSION "${VISP_VERSION_MAJOR}${VISP_VERSION_MINOR}${VISP_VERSION_PATCH}")
else()
  set(VISP_DEBUG_POSTFIX "")
  set(VISP_DLLVERSION "")
endif()

# --- Python Support ---
if(NOT IOS AND NOT VISP_PYTHON_SKIP_DETECTION)
  # Make sure to refresh the python interpreter every time we rerun cmake
  # If we don't do this, we may use an old or invalid python when installing the bindings
  # that was cached by a previous attempt at building
  if(CMAKE_VERSION VERSION_LESS "3.15.0")
    set(PYTHON3_CACHE_LIST
      PYTHON3INTERP_FOUND PYTHONINTERP_FOUND PYTHONLIBS_FOUND PYTHON_FOUND
      PYTHON3_EXECUTABLE PYTHON_EXECUTABLE
    )
    foreach (_variableName ${PYTHON3_CACHE_LIST})
      unset(${_variableName} CACHE)
    endforeach()
    include(cmake/VISPDetectPython.cmake)
  else()

=== apps/CMakeLists.txt ===
#############################################################################
#
# ViSP, open source Visual Servoing Platform software.
# Copyright (C) 2005 - 2025 by Inria. All rights reserved.
#
# This software is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# See the file LICENSE.txt at the root directory of this source
# distribution for additional information about the GNU GPL.
#
# For using ViSP with software that can not be combined with the GNU
# GPL, please contact Inria about acquiring a ViSP Professional
# Edition License.
#
# See https://visp.inria.fr for more information.
#
# This software was developed at:
# Inria Rennes - Bretagne Atlantique
# Campus Universitaire de Beaulieu
# 35042 Rennes Cedex
# France
#
# If you have questions regarding the use of this file, please contact
# Inria at visp@inria.fr
#
# This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
# WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#
# Description:
# ViSP overall configuration file.
#
#############################################################################

cmake_minimum_required(VERSION 3.10)

project(ViSP-apps)

find_package(VISP)

if(MSVC)
  if(NOT VISP_SHARED)
    foreach(flag_var
            CMAKE_C_FLAGS CMAKE_C_FLAGS_DEBUG CMAKE_C_FLAGS_RELEASE
            CMAKE_C_FLAGS_MINSIZEREL CMAKE_C_FLAGS_RELWITHDEBINFO
            CMAKE_CXX_FLAGS CMAKE_CXX_FLAGS_DEBUG CMAKE_CXX_FLAGS_RELEASE
            CMAKE_CXX_FLAGS_MINSIZEREL CMAKE_CXX_FLAGS_RELWITHDEBINFO)
      if(${flag_var} MATCHES "/MD")
        string(REGEX REPLACE "/MD" "/MT" ${flag_var} "${${flag_var}}")
      endif()
      if(${flag_var} MATCHES "/MDd")
        string(REGEX REPLACE "/MDd" "/MTd" ${flag_var} "${${flag_var}}")
      endif()
    endforeach(flag_var)

    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} /NODEFAULTLIB:atlthunk.lib /NODEFAULTLIB:msvcrt.lib /NODEFAULTLIB:msvcrtd.lib")
    set(CMAKE_EXE_LINKER_FLAGS_DEBUG "${CMAKE_EXE_LINKER_FLAGS_DEBUG} /NODEFAULTLIB:libcmt.lib")
    set(CMAKE_EXE_LINKER_FLAGS_RELEASE "${CMAKE_EXE_LINKER_FLAGS_RELEASE} /NODEFAULTLIB:libcmtd.lib")
  endif()
endif()

visp_add_subdirectory(calibration REQUIRED_DEPS visp_core visp_gui visp_io visp_robot visp_sensor visp_vision)
visp_add_subdirectory(rs-dataset REQUIRED_DEPS visp_core visp_sensor visp_io visp_gui)

=== demo/CMakeLists.txt ===
#############################################################################
#
# ViSP, open source Visual Servoing Platform software.
# Copyright (C) 2005 - 2025 by Inria. All rights reserved.
#
# This software is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# See the file LICENSE.txt at the root directory of this source
# distribution for additional information about the GNU GPL.
#
# For using ViSP with software that can not be combined with the GNU
# GPL, please contact Inria about acquiring a ViSP Professional
# Edition License.
#
# See https://visp.inria.fr for more information.
#
# This software was developed at:
# Inria Rennes - Bretagne Atlantique
# Campus Universitaire de Beaulieu
# 35042 Rennes Cedex
# France
#
# If you have questions regarding the use of this file, please contact
# Inria at visp@inria.fr
#
# This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
# WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#
# Description:
# ViSP overall configuration file.
#
#############################################################################

cmake_minimum_required(VERSION 3.10)

project(ViSP-demo)

find_package(VISP)

if(MSVC)
  if(NOT VISP_SHARED)
    foreach(flag_var
            CMAKE_C_FLAGS CMAKE_C_FLAGS_DEBUG CMAKE_C_FLAGS_RELEASE
            CMAKE_C_FLAGS_MINSIZEREL CMAKE_C_FLAGS_RELWITHDEBINFO
            CMAKE_CXX_FLAGS CMAKE_CXX_FLAGS_DEBUG CMAKE_CXX_FLAGS_RELEASE
            CMAKE_CXX_FLAGS_MINSIZEREL CMAKE_CXX_FLAGS_RELWITHDEBINFO)
      if(${flag_var} MATCHES "/MD")
        string(REGEX REPLACE "/MD" "/MT" ${flag_var} "${${flag_var}}")
      endif()
      if(${flag_var} MATCHES "/MDd")
        string(REGEX REPLACE "/MDd" "/MTd" ${flag_var} "${${flag_var}}")
      endif()
    endforeach(flag_var)

    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} /NODEFAULTLIB:atlthunk.lib /NODEFAULTLIB:msvcrt.lib /NODEFAULTLIB:msvcrtd.lib")
    set(CMAKE_EXE_LINKER_FLAGS_DEBUG "${CMAKE_EXE_LINKER_FLAGS_DEBUG} /NODEFAULTLIB:libcmt.lib")
    set(CMAKE_EXE_LINKER_FLAGS_RELEASE "${CMAKE_EXE_LINKER_FLAGS_RELEASE} /NODEFAULTLIB:libcmtd.lib")
  endif()
endif()

visp_add_subdirectory(wireframe-simulator REQUIRED_DEPS visp_core visp_robot visp_vs visp_io visp_gui)

=== example/CMakeLists.txt ===
#############################################################################
#
# ViSP, open source Visual Servoing Platform software.
# Copyright (C) 2005 - 2025 by Inria. All rights reserved.
#
# This software is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# See the file LICENSE.txt at the root directory of this source
# distribution for additional information about the GNU GPL.
#
# For using ViSP with software that can not be combined with the GNU
# GPL, please contact Inria about acquiring a ViSP Professional
# Edition License.
#
# See https://visp.inria.fr for more information.
#
# This software was developed at:
# Inria Rennes - Bretagne Atlantique
# Campus Universitaire de Beaulieu
# 35042 Rennes Cedex
# France
#
# If you have questions regarding the use of this file, please contact
# Inria at visp@inria.fr
#
# This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
# WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#
# Description:
# ViSP overall configuration file.
#
#############################################################################

cmake_minimum_required(VERSION 3.10)

project(ViSP-examples)

find_package(VISP)

if(MSVC)
  if(NOT VISP_SHARED)
    foreach(flag_var
            CMAKE_C_FLAGS CMAKE_C_FLAGS_DEBUG CMAKE_C_FLAGS_RELEASE
            CMAKE_C_FLAGS_MINSIZEREL CMAKE_C_FLAGS_RELWITHDEBINFO
            CMAKE_CXX_FLAGS CMAKE_CXX_FLAGS_DEBUG CMAKE_CXX_FLAGS_RELEASE
            CMAKE_CXX_FLAGS_MINSIZEREL CMAKE_CXX_FLAGS_RELWITHDEBINFO)
      if(${flag_var} MATCHES "/MD")
        string(REGEX REPLACE "/MD" "/MT" ${flag_var} "${${flag_var}}")
      endif()
      if(${flag_var} MATCHES "/MDd")
        string(REGEX REPLACE "/MDd" "/MTd" ${flag_var} "${${flag_var}}")
      endif()
    endforeach(flag_var)

    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} /NODEFAULTLIB:atlthunk.lib /NODEFAULTLIB:msvcrt.lib /NODEFAULTLIB:msvcrtd.lib")
    set(CMAKE_EXE_LINKER_FLAGS_DEBUG "${CMAKE_EXE_LINKER_FLAGS_DEBUG} /NODEFAULTLIB:libcmt.lib")
    set(CMAKE_EXE_LINKER_FLAGS_RELEASE "${CMAKE_EXE_LINKER_FLAGS_RELEASE} /NODEFAULTLIB:libcmtd.lib")
  endif()
endif()

visp_add_subdirectory(coin-simulator           REQUIRED_DEPS visp_core visp_robot visp_vs visp_ar visp_io)
visp_add_subdirectory(device/display           REQUIRED_DEPS visp_core visp_gui visp_io)
visp_add_subdirectory(device/framegrabber      REQUIRED_DEPS visp_core visp_sensor visp_io visp_gui)
visp_add_subdirectory(device/kinect            REQUIRED_DEPS visp_core visp_sensor visp_gui)
visp_add_subdirectory(device/laserscanner      REQUIRED_DEPS visp_core visp_sensor visp_gui visp_io)
visp_add_subdirectory(device/light             REQUIRED_DEPS visp_core visp_robot visp_io)
visp_add_subdirectory(direct-visual-servoing   REQUIRED_DEPS visp_core visp_robot visp_visual_features visp_io visp_gui)
visp_add_subdirectory(homography               REQUIRED_DEPS visp_core visp_vision visp_io)
visp_add_subdirectory(image                    REQUIRED_DEPS visp_core visp_io)
visp_add_subdirectory(kalman                   REQUIRED_DEPS visp_core visp_gui)
visp_add_subdirectory(manual                   REQUIRED_DEPS visp_core visp_sensor visp_vs visp_robot visp_ar visp_vision visp_io visp_gui)
visp_add_subdirectory(math                     REQUIRED_DEPS visp_core visp_gui visp_io)
visp_add_subdirectory(moments/image            REQUIRED_DEPS visp_core visp_vs visp_robot visp_gui)
visp_add_subdirectory(moments/points           REQUIRED_DEPS visp_core visp_vs visp_robot visp_gui)
visp_add_subdirectory(moments/polygon          REQUIRED_DEPS visp_core visp_vs visp_robot visp_gui)
visp_add_subdirectory(ogre-simulator           REQUIRED_DEPS visp_core visp_vision visp_ar visp_blob visp_io visp_gui)
visp_add_subdirectory(parse-argv               REQUIRED_DEPS visp_core visp_io)
visp_add_subdirectory(particle-filter          REQUIRED_DEPS visp_core visp_gui)
visp_add_subdirectory(pose-estimation          REQUIRED_DEPS visp_core visp_blob visp_vision visp_io visp_gui)
visp_add_subdirectory(reflex-takktile          REQUIRED_DEPS visp_core visp_robot)
visp_add_subdirectory(robot-simulator/afma6    REQUIRED_DEPS visp_core visp_vs visp_robot visp_io visp_gui)
visp_add_subdirectory(robot-simulator/camera   REQUIRED_DEPS visp_core visp_vs visp_robot visp_io visp_gui)
visp_add_subdirectory(robot-simulator/viper850 REQUIRED_DEPS visp_core visp_vs visp_robot visp_io visp_gui)
visp_add_subdirectory(servo-afma6              REQUIRED_DEPS visp_core visp_blob visp_vs visp_robot visp_sensor visp_vision visp_gui)
visp_add_subdirectory(servo-biclops            REQUIRED_DEPS visp_core visp_detection visp_vs visp_robot visp_sensor visp_gui)
visp_add_subdirectory(servo-bebop2             REQUIRED_DEPS visp_core visp_vs visp_robot visp_gui visp_detection)
visp_add_subdirectory(servo-flir-ptu           REQUIRED_DEPS visp_core visp_robot visp_vision visp_gui visp_vs visp_visual_features visp_detection visp_sensor)
visp_add_subdirectory(servo-franka             REQUIRED_DEPS visp_core visp_robot visp_vision visp_io visp_gui visp_vs visp_visual_features visp_detection)
visp_add_subdirectory(servo-kinova             REQUIRED_DEPS visp_core visp_robot visp_vision visp_io visp_gui visp_vs visp_visual_features visp_detection)
visp_add_subdirectory(servo-pioneer            REQUIRED_DEPS visp_core visp_blob visp_vs visp_robot visp_sensor visp_gui)
visp_add_subdirectory(servo-pixhawk            REQUIRED_DEPS visp_core visp_vs visp_robot visp_gui visp_detection visp_sensor)
visp_add_subdirectory(servo-pololu-ptu         REQUIRED_DEPS visp_core visp_robot visp_vision visp_gui visp_vs visp_visual_features visp_detection visp_sensor)
visp_add_subdirectory(servo-ptu46              REQUIRED_DEPS visp_core visp_blob visp_vs visp_robot visp_sensor visp_gui)
visp_add_subdirectory(servo-universal-robots   REQUIRED_DEPS visp_core visp_robot visp_io)
visp_add_subdirectory(servo-viper650           REQUIRED_DEPS visp_core visp_blob visp_vs visp_robot visp_sensor visp_vision visp_gui)
visp_add_subdirectory(servo-viper850           REQUIRED_DEPS visp_core visp_blob visp_vs visp_robot visp_sensor visp_vision visp_gui)
visp_add_subdirectory(tools                    REQUIRED_DEPS visp_core visp_robot visp_io visp_gui)
visp_add_subdirectory(tracking                 REQUIRED_DEPS visp_core visp_core visp_blob visp_io visp_gui visp_mbt visp_me visp_tt visp_tt_mi)
visp_add_subdirectory(video                    REQUIRED_DEPS visp_core visp_io visp_gui)
visp_add_subdirectory(wireframe-simulator      REQUIRED_DEPS visp_core visp_robot visp_io visp_gui)

=== modules/CMakeLists.txt ===
#############################################################################
#
# ViSP, open source Visual Servoing Platform software.
# Copyright (C) 2005 - 2025 by Inria. All rights reserved.
#
# This software is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# See the file LICENSE.txt at the root directory of this source
# distribution for additional information about the GNU GPL.
#
# For using ViSP with software that can not be combined with the GNU
# GPL, please contact Inria about acquiring a ViSP Professional
# Edition License.
#
# See https://visp.inria.fr for more information.
#
# This software was developed at:
# Inria Rennes - Bretagne Atlantique
# Campus Universitaire de Beaulieu
# 35042 Rennes Cedex
# France
#
# If you have questions regarding the use of this file, please contact
# Inria at visp@inria.fr
#
# This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
# WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#
# Description:
# ViSP configuration file.
#
#############################################################################

if(NOT VISP_MODULES_PATH)
  set(VISP_MODULES_PATH "${CMAKE_CURRENT_SOURCE_DIR}")
endif()

# extra modules are outside ViSP. Useful for contrib or specific additional modules
vp_glob_modules(${VISP_MODULES_PATH} EXTRA ${VISP_CONTRIB_MODULES_PATH})

=== samples/CMakeLists.txt ===
# ----------------------------------------------------------------------------
#  CMake file for Android samples. See root CMakeLists.txt
#
# ----------------------------------------------------------------------------

install(DIRECTORY android/app DESTINATION ${ANDROID_INSTALL_SAMPLES_DIR})
install(DIRECTORY android/gradle DESTINATION ${ANDROID_INSTALL_SAMPLES_DIR})
install(FILES android/settings.gradle DESTINATION ${ANDROID_INSTALL_SAMPLES_DIR})
install(FILES android/build.gradle DESTINATION ${ANDROID_INSTALL_SAMPLES_DIR})
configure_file("android/local.properties.in" "${ANDROID_TMP_INSTALL_BASE_DIR}/${ANDROID_INSTALL_SAMPLES_DIR}/local.properties" @ONLY)
install(FILES "${ANDROID_TMP_INSTALL_BASE_DIR}/${ANDROID_INSTALL_SAMPLES_DIR}/local.properties" DESTINATION "${ANDROID_INSTALL_SAMPLES_DIR}" COMPONENT samples)

=== tutorial/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

project(ViSP-tutorial)

find_package(VISP REQUIRED)

if(MSVC)
  if(NOT VISP_SHARED)
    foreach(flag_var
            CMAKE_C_FLAGS CMAKE_C_FLAGS_DEBUG CMAKE_C_FLAGS_RELEASE
            CMAKE_C_FLAGS_MINSIZEREL CMAKE_C_FLAGS_RELWITHDEBINFO
            CMAKE_CXX_FLAGS CMAKE_CXX_FLAGS_DEBUG CMAKE_CXX_FLAGS_RELEASE
            CMAKE_CXX_FLAGS_MINSIZEREL CMAKE_CXX_FLAGS_RELWITHDEBINFO)
      if(${flag_var} MATCHES "/MD")
        string(REGEX REPLACE "/MD" "/MT" ${flag_var} "${${flag_var}}")
      endif()
      if(${flag_var} MATCHES "/MDd")
        string(REGEX REPLACE "/MDd" "/MTd" ${flag_var} "${${flag_var}}")
      endif()
    endforeach(flag_var)

    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} /NODEFAULTLIB:atlthunk.lib /NODEFAULTLIB:msvcrt.lib /NODEFAULTLIB:msvcrtd.lib")
    set(CMAKE_EXE_LINKER_FLAGS_DEBUG "${CMAKE_EXE_LINKER_FLAGS_DEBUG} /NODEFAULTLIB:libcmt.lib")
    set(CMAKE_EXE_LINKER_FLAGS_RELEASE "${CMAKE_EXE_LINKER_FLAGS_RELEASE} /NODEFAULTLIB:libcmtd.lib")
  endif()
endif()

visp_add_subdirectory(ar                                   REQUIRED_DEPS visp_core visp_gui visp_ar)
visp_add_subdirectory(bridge/opencv                        REQUIRED_DEPS visp_core visp_io)
visp_add_subdirectory(computer-vision                      REQUIRED_DEPS visp_core visp_blob visp_vision visp_io visp_gui visp_detection visp_sensor)
visp_add_subdirectory(grabber                              REQUIRED_DEPS visp_core visp_sensor visp_io visp_gui)
visp_add_subdirectory(gui/pcl-visualizer                   REQUIRED_DEPS visp_core visp_gui visp_io)
visp_add_subdirectory(detection/barcode                    REQUIRED_DEPS visp_core visp_detection visp_io visp_gui visp_sensor)
visp_add_subdirectory(detection/dnn                        REQUIRED_DEPS visp_core visp_detection visp_io visp_gui visp_sensor)
visp_add_subdirectory(detection/face                       REQUIRED_DEPS visp_core visp_detection visp_io visp_gui visp_sensor)
visp_add_subdirectory(detection/matching                   REQUIRED_DEPS visp_core visp_vision visp_io visp_gui)
visp_add_subdirectory(detection/object                     REQUIRED_DEPS visp_core visp_vision visp_mbt visp_io visp_gui)
visp_add_subdirectory(detection/tag                        REQUIRED_DEPS visp_core visp_detection visp_io visp_gui visp_sensor)
visp_add_subdirectory(image                                REQUIRED_DEPS visp_core visp_io visp_gui)
visp_add_subdirectory(imgproc/autothreshold                REQUIRED_DEPS visp_core visp_io visp_gui visp_imgproc)
visp_add_subdirectory(imgproc/brightness                   REQUIRED_DEPS visp_core visp_io visp_gui visp_imgproc)
visp_add_subdirectory(imgproc/connected-components         REQUIRED_DEPS visp_core visp_io visp_gui visp_imgproc)
visp_add_subdirectory(imgproc/contour                      REQUIRED_DEPS visp_core visp_io visp_gui visp_imgproc)
visp_add_subdirectory(imgproc/contrast-sharpening          REQUIRED_DEPS visp_core visp_io visp_gui visp_imgproc)
visp_add_subdirectory(imgproc/count-coins                  REQUIRED_DEPS visp_core visp_io visp_gui visp_imgproc)
visp_add_subdirectory(imgproc/flood-fill                   REQUIRED_DEPS visp_core visp_io visp_gui visp_imgproc)
visp_add_subdirectory(imgproc/hough-transform              REQUIRED_DEPS visp_core visp_gui visp_imgproc)
visp_add_subdirectory(kalman                               REQUIRED_DEPS visp_core visp_gui visp_vision)
visp_add_subdirectory(mean-drift                           REQUIRED_DEPS visp_core visp_gui)
visp_add_subdirectory(misc/npz                             REQUIRED_DEPS visp_core visp_gui visp_io)
visp_add_subdirectory(munkres                              REQUIRED_DEPS visp_core visp_gui)
visp_add_subdirectory(particle-filter                      REQUIRED_DEPS visp_core visp_io visp_gui visp_vision)
visp_add_subdirectory(particle-filter-curve-fitting        REQUIRED_DEPS visp_core visp_io visp_gui)
visp_add_subdirectory(robot/flir-ptu                       REQUIRED_DEPS visp_core visp_robot visp_sensor visp_vision visp_gui visp_vs visp_visual_features visp_detection)
visp_add_subdirectory(robot/pioneer                        REQUIRED_DEPS visp_core visp_robot visp_vs visp_gui)
visp_add_subdirectory(robot/mbot/raspberry/visp            REQUIRED_DEPS visp_core visp_detection visp_io visp_gui visp_sensor visp_vs)
visp_add_subdirectory(segmentation/color                   REQUIRED_DEPS visp_core visp_sensor visp_io visp_gui)
visp_add_subdirectory(simulator/image                      REQUIRED_DEPS visp_core visp_robot visp_io visp_gui)
visp_add_subdirectory(trace                                REQUIRED_DEPS visp_core)
visp_add_subdirectory(tracking/blob                        REQUIRED_DEPS visp_core visp_blob visp_io visp_gui visp_sensor)
visp_add_subdirectory(tracking/keypoint                    REQUIRED_DEPS visp_core visp_vision visp_klt visp_io visp_gui visp_sensor)
visp_add_subdirectory(tracking/model-based/generic         REQUIRED_DEPS visp_core visp_mbt visp_io visp_gui visp_sensor)
visp_add_subdirectory(tracking/model-based/generic-apriltag REQUIRED_DEPS visp_core visp_sensor visp_gui visp_vision visp_mbt visp_detection)
visp_add_subdirectory(tracking/model-based/generic-rgbd    REQUIRED_DEPS visp_core visp_mbt visp_io visp_gui visp_sensor)
visp_add_subdirectory(tracking/model-based/generic-rgbd-blender REQUIRED_DEPS visp_core visp_mbt visp_io visp_gui)
visp_add_subdirectory(tracking/model-based/generic-stereo  REQUIRED_DEPS visp_core visp_mbt visp_io visp_gui)
visp_add_subdirectory(tracking/model-based/old/edges       REQUIRED_DEPS visp_core visp_mbt visp_io visp_gui)
visp_add_subdirectory(tracking/model-based/old/generic     REQUIRED_DEPS visp_core visp_mbt visp_io visp_gui)
visp_add_subdirectory(tracking/model-based/old/hybrid      REQUIRED_DEPS visp_core visp_mbt visp_klt visp_io visp_gui)
visp_add_subdirectory(tracking/model-based/old/keypoint    REQUIRED_DEPS visp_core visp_mbt visp_klt visp_io visp_gui)
visp_add_subdirectory(tracking/render-based                REQUIRED_DEPS visp_core visp_rbt visp_io visp_gui visp_sensor)

visp_add_subdirectory(tracking/template-tracker            REQUIRED_DEPS visp_core visp_tt visp_io visp_gui)
visp_add_subdirectory(tracking/moving-edges                REQUIRED_DEPS visp_core visp_me visp_io visp_gui visp_sensor)
visp_add_subdirectory(tracking/dnn                         REQUIRED_DEPS visp_core visp_detection visp_dnn_tracker visp_io visp_gui visp_sensor)
visp_add_subdirectory(visual-servo/ibvs                    REQUIRED_DEPS visp_core visp_robot visp_vs visp_blob visp_vision visp_io visp_gui visp_ar)

=== 3rdparty/apriltag/CMakeLists.txt ===
project(${APRILTAG_LIBRARY} LANGUAGES C)

set(APRILTAG_MAJOR_VERSION 3 PARENT_SCOPE)
set(APRILTAG_MINOR_VERSION 4 PARENT_SCOPE)
set(APRILTAG_PATCH_VERSION 2 PARENT_SCOPE)

vp_include_directories(${CMAKE_CURRENT_SOURCE_DIR})

file(GLOB tag_srcs tag*.c)
file(GLOB lib_srcs *.c common/*.c)
file(GLOB lib_hdrs *.h common/*.h common/sys/*.h)

vp_list_filterout(lib_srcs common/unionfind.c) # has no symbols

if(NOT WITH_APRILTAG_BIG_FAMILY)
  vp_list_filterout(lib_srcs tagCircle49h12.c)
  vp_list_filterout(lib_hdrs tagCircle49h12.h)
  vp_list_filterout(lib_srcs tagCustom48h12.c)
  vp_list_filterout(lib_hdrs tagCustom48h12.h)
  vp_list_filterout(lib_srcs tagStandard41h12.c)
  vp_list_filterout(lib_hdrs tagStandard41h12.h)
  vp_list_filterout(lib_srcs tagStandard52h13.c)
  vp_list_filterout(lib_hdrs tagStandard52h13.h)
endif()

if(NOT (WIN32 AND NOT MINGW))
  vp_list_filterout(lib_srcs pthreads_cross.c)
endif()

if(UNIX)
  if(CMAKE_COMPILER_IS_GNUCXX OR CV_ICC)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -U__STRICT_ANSI__ -fPIC -std=c99")
  endif()
endif()

add_library(${APRILTAG_LIBRARY} STATIC ${lib_srcs} ${lib_hdrs})

if(ENABLE_SOLUTION_FOLDERS)
  set_target_properties(${APRILTAG_LIBRARY} PROPERTIES FOLDER "3rdparty")
endif()

if(VISP_CXX_STANDARD EQUAL VISP_CXX_STANDARD_98)
  set(CMAKE_C_STANDARD 99)
  set(CMAKE_C_STANDARD_REQUIRED TRUE)
  if(UNIX)
    if(CMAKE_COMPILER_IS_GNUCXX OR CV_ICC)
      set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -U__STRICT_ANSI__")
    endif()
  endif()
endif()

set_target_properties(${APRILTAG_LIBRARY}
  PROPERTIES OUTPUT_NAME ${APRILTAG_LIBRARY}
  DEBUG_POSTFIX "${VISP_DEBUG_POSTFIX}"
  COMPILE_PDB_NAME ${APRILTAG_LIBRARY}
  COMPILE_PDB_NAME_DEBUG "${APRILTAG_LIBRARY}${VISP_DEBUG_POSTFIX}"
  ARCHIVE_OUTPUT_DIRECTORY ${VISP_3P_LIBRARY_OUTPUT_PATH}
  )

if(NOT BUILD_SHARED_LIBS)
  vp_install_target(${APRILTAG_LIBRARY} EXPORT VISPModules ARCHIVE DESTINATION ${VISP_3P_LIB_INSTALL_PATH} COMPONENT dev)
endif()

if(MSVC AND (CMAKE_CXX_COMPILER_ID MATCHES "Clang"))
  # Mute warning : 'strdup' is deprecated: The POSIX name for this item is deprecated. Instead, use the ISO C and C++ conformant name: _strdup. See online help for details. [-Wdeprecated-declarations]
  foreach(f ${tag_srcs})
    vp_set_source_file_compile_flag(${f} -Wno-deprecated-declarations)
  endforeach()
  foreach(f ${lib_srcs})
    vp_set_source_file_compile_flag(${f} -Wno-deprecated-declarations)
  endforeach()
elseif(MSVC)
  if(BUILD_SHARED_LIBS)
    vp_warnings_disable(CMAKE_CXX_FLAGS /wd4018 /wd4098 /wd4200 /wd4244 /wd4267 /wd4305 /wd4334 /wd4244 /wd4838 /wd4996 /wd6011 /wd6385 /wd6386 /wd6387 /wd6011 /wd26451)
    vp_set_source_file_compile_flag(common/matd.c /wd4244)
    vp_set_source_file_compile_flag(common/g2d.c /wd4244)
    vp_set_source_file_compile_flag(common/homography.c /wd4244)
    vp_set_source_file_compile_flag(common/image_u8.c /wd4244)
    vp_set_source_file_compile_flag(common/image_u8x3.c /wd4244)
    vp_set_source_file_compile_flag(common/image_u8_parallel.c /wd4244)
    vp_set_source_file_compile_flag(common/pam.c /wd4018)
    vp_set_source_file_compile_flag(common/pthreads_cross.c /wd4068 /wd4244)
    vp_set_source_file_compile_flag(common/string_util.c /wd4018 /wd4267 /wd4996)
    vp_set_source_file_compile_flag(common/time_util.c /wd4244)
    vp_set_source_file_compile_flag(common/times.c /wd4244)
    vp_set_source_file_compile_flag(common/workerpool.c /wd4018 /wd4244)
    vp_set_source_file_compile_flag(common/zmaxheap.c /wd4098 /wd4244)
    vp_set_source_file_compile_flag(apriltag.c /wd4244)
    vp_set_source_file_compile_flag(apriltag_pose.c /wd4244)
    vp_set_source_file_compile_flag(apriltag_quad_thresh.c /wd4244)
    vp_set_source_file_compile_flag(tag16h5.c /wd4996 /wd4244)
    vp_set_source_file_compile_flag(tag25h7.c /wd4996 /wd4244)
    vp_set_source_file_compile_flag(tag25h9.c /wd4996 /wd4244)
    vp_set_source_file_compile_flag(tag36h10.c /wd4996 /wd4244)
    vp_set_source_file_compile_flag(tag36h11.c /wd4996 /wd4244)
    vp_set_source_file_compile_flag(tagCircle21h7.c /wd4996 /wd4244)
    vp_set_source_file_compile_flag(tagAruco4x4_50.c /wd4996 /wd4244)
    vp_set_source_file_compile_flag(tagAruco4x4_100.c /wd4996 /wd4244)
    vp_set_source_file_compile_flag(tagAruco4x4_250.c /wd4996 /wd4244)
    vp_set_source_file_compile_flag(tagAruco4x4_1000.c /wd4996 /wd4244)
    vp_set_source_file_compile_flag(tagAruco5x5_50.c /wd4996 /wd4244)
    vp_set_source_file_compile_flag(tagAruco5x5_100.c /wd4996 /wd4244)
    vp_set_source_file_compile_flag(tagAruco5x5_250.c /wd4996 /wd4244)
    vp_set_source_file_compile_flag(tagAruco5x5_1000.c /wd4996 /wd4244)
    vp_set_source_file_compile_flag(tagAruco6x6_50.c /wd4996 /wd4244)
    vp_set_source_file_compile_flag(tagAruco6x6_100.c /wd4996 /wd4244)
    vp_set_source_file_compile_flag(tagAruco6x6_250.c /wd4996 /wd4244)
    vp_set_source_file_compile_flag(tagAruco6x6_1000.c /wd4996 /wd4244)
    vp_set_source_file_compile_flag(tagAruco7x7_50.c /wd4996 /wd4244)
    vp_set_source_file_compile_flag(tagAruco7x7_100.c /wd4996 /wd4244)
    vp_set_source_file_compile_flag(tagAruco7x7_250.c /wd4996 /wd4244)
    vp_set_source_file_compile_flag(tagAruco7x7_1000.c /wd4996 /wd4244)
    vp_set_source_file_compile_flag(tagAruco_MIP_36h12.c /wd4996 /wd4244)
    # disable optimization
    foreach(f ${tag_srcs})
      vp_set_source_file_compile_flag(${f} /O0)
    endforeach()
  else()
    vp_warnings_disable(CMAKE_CXX_FLAGS /wd4018 /wd4098 /wd4244 /wd4267 /wd4305 /wd4334 /wd4244 /wd4838 /wd4996)
  endif()
elseif(MINGW)
  foreach(f ${lib_srcs})
    vp_set_source_file_compile_flag(${f} -Wno-deprecated -Wno-sign-compare -Wno-unused-parameter -Wno-unused-variable -Wno-float-equal -Wno-strict-overflow -Wno-type-limits -Wno-shift-negative-value)
  endforeach()
  # disable optimization
  foreach(f ${tag_srcs})
    vp_set_source_file_compile_flag(${f} -O0)
  endforeach()
else()
  foreach(f ${lib_srcs})
    vp_set_source_file_compile_flag(${f} -Wno-deprecated -Wno-sign-compare -Wno-unused-parameter -Wno-unused-variable -Wno-float-equal -Wno-strict-overflow -Wno-type-limits -Wno-shift-negative-value -Wno-shorten-64-to-32 -Wno-attributes)
  endforeach()
  # disable optimization
  foreach(f ${tag_srcs})
    vp_set_source_file_compile_flag(${f} -O0)
  endforeach()
endif()

=== 3rdparty/catch2/CMakeLists.txt ===
project(${CATCH2_LIBRARY})

set(CATCH2_MAJOR_VERSION 3 PARENT_SCOPE)
set(CATCH2_MINOR_VERSION 7 PARENT_SCOPE)
set(CATCH2_PATCH_VERSION 1 PARENT_SCOPE)

vp_include_directories(${CMAKE_CURRENT_SOURCE_DIR})

file(GLOB lib_srcs *.cpp)
file(GLOB lib_hdrs *.hpp)

add_library(${CATCH2_LIBRARY} STATIC ${lib_srcs} ${lib_hdrs})
target_compile_definitions(${CATCH2_LIBRARY} PRIVATE "CATCH_AMALGAMATED_CUSTOM_MAIN")

if(UNIX)
  if(CMAKE_COMPILER_IS_GNUCXX OR CV_ICC)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC")
  endif()
endif()

if((VISP_CXX_STANDARD EQUAL VISP_CXX_STANDARD_11) AND CXX11_CXX_FLAGS)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CXX11_CXX_FLAGS}")
elseif((VISP_CXX_STANDARD EQUAL VISP_CXX_STANDARD_14) AND CXX14_CXX_FLAGS)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CXX14_CXX_FLAGS}")
elseif((VISP_CXX_STANDARD EQUAL VISP_CXX_STANDARD_17) AND CXX17_CXX_FLAGS)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CXX17_CXX_FLAGS}")
endif()

if(ENABLE_SOLUTION_FOLDERS)
  set_target_properties(${CATCH2_LIBRARY} PROPERTIES FOLDER "3rdparty")
endif()

set_target_properties(${CATCH2_LIBRARY}
  PROPERTIES OUTPUT_NAME ${CATCH2_LIBRARY}
  DEBUG_POSTFIX "${VISP_DEBUG_POSTFIX}"
  COMPILE_PDB_NAME ${CATCH2_LIBRARY}
  COMPILE_PDB_NAME_DEBUG "${CATCH2_LIBRARY}${VISP_DEBUG_POSTFIX}"
  ARCHIVE_OUTPUT_DIRECTORY ${VISP_3P_LIBRARY_OUTPUT_PATH}
  )

if(NOT BUILD_SHARED_LIBS)
  vp_install_target(${CATCH2_LIBRARY} EXPORT VISPModules ARCHIVE DESTINATION ${VISP_3P_LIB_INSTALL_PATH} COMPONENT dev)
endif()

=== 3rdparty/clapack/CMakeLists.txt ===
project(${LAPACK_LIBRARY} C)

if(UNIX)
  if(CMAKE_COMPILER_IS_GNUCXX OR CV_ICC)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fPIC")
  endif()
endif()

set(LAPACK_MAJOR_VERSION 3 PARENT_SCOPE)
set(LAPACK_MINOR_VERSION 2 PARENT_SCOPE)
set(LAPACK_PATCH_VERSION 1 PARENT_SCOPE)

add_definitions(-DNO_BLAS_WRAP)
if(WIN32 AND MSVC)
  add_definitions(-DMSDOS -DNO_ISATTY)
endif()

file(GLOB lib_srcs src/*.c blas/*.c install/*.c f2c/*.c)
file(GLOB lib_incs include/*.h)

add_library(${LAPACK_LIBRARY} STATIC ${lib_srcs} ${lib_incs})
vp_target_include_directories(${LAPACK_LIBRARY} PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/include)

if(ENABLE_SOLUTION_FOLDERS)
  set_target_properties(${LAPACK_LIBRARY} PROPERTIES FOLDER "3rdparty")
endif()

set_target_properties(${LAPACK_LIBRARY}
  PROPERTIES OUTPUT_NAME ${LAPACK_LIBRARY}
  DEBUG_POSTFIX "${VISP_DEBUG_POSTFIX}"
  COMPILE_PDB_NAME ${LAPACK_LIBRARY}
  COMPILE_PDB_NAME_DEBUG "${LAPACK_LIBRARY}${VISP_DEBUG_POSTFIX}"
  ARCHIVE_OUTPUT_DIRECTORY ${VISP_3P_LIBRARY_OUTPUT_PATH}
  )

if(NOT BUILD_SHARED_LIBS)
  vp_install_target(${LAPACK_LIBRARY} EXPORT VISPModules ARCHIVE DESTINATION ${VISP_3P_LIB_INSTALL_PATH} COMPONENT dev)
endif()

if(MSVC AND NOT ((CMAKE_CXX_COMPILER_ID MATCHES "AppleClang") OR (CMAKE_CXX_COMPILER_ID MATCHES "Clang")))
  # Disable Visual C++ warnings
  foreach(f ${lib_srcs})
    vp_set_source_file_compile_flag(${f} /wd4244 /wd4267 /wd4273 /wd4554 /wd4723 /wd4996)
  endforeach()
else()
  foreach(f ${lib_srcs})
    vp_set_source_file_compile_flag(${f} -Wno-logical-op-parentheses -Wno-shift-op-parentheses -Wno-parentheses -Wno-format-extra-args -Wno-format -Wno-sign-compare -Wno-uninitialized -Wno-unused-but-set-variable -Wno-unused-parameter -Wno-unused-variable)
  endforeach()
endif()

=== 3rdparty/pololu/CMakeLists.txt ===
project(${POLOLU_LIBRARY})

set(POLOLU_MAJOR_VERSION 1 PARENT_SCOPE)
set(POLOLU_MINOR_VERSION 0 PARENT_SCOPE)
set(POLOLU_PATCH_VERSION 0 PARENT_SCOPE)

vp_include_directories(${CMAKE_CURRENT_SOURCE_DIR}/include)

set(lib_srcs src/RPMSerialInterface.cpp)
set(lib_hdrs include/RPMSerialInterface.h)

if(CMAKE_SYSTEM_NAME MATCHES "Windows")
	list(APPEND lib_hdrs include/RPMSerialInterfaceWindows.h)
	list(APPEND lib_srcs src/RPMSerialInterfaceWindows.cpp)
elseif(CMAKE_SYSTEM_NAME MATCHES "Linux" OR CMAKE_SYSTEM_NAME MATCHES "Darwin" OR CMAKE_SYSTEM_NAME MATCHES "FreeBSD")
  # Could also be used on Windows with MinGW
  list(APPEND lib_hdrs include/RPMSerialInterfacePOSIX.h)
  list(APPEND lib_srcs src/RPMSerialInterfacePOSIX.cpp)
else()
	message("${PROJECT_NAME} is only available for Windows, Linux and Darwin. Disabled for ${CMAKE_SYSTEM_NAME}")
  unset(WITH_POLOLU)
  set(WITH_POLOLU OFF CACHE BOOL "Build rapa pololu as built-in library" FORCE)
  return()
endif()

add_library(${POLOLU_LIBRARY} STATIC ${lib_srcs} ${lib_hdrs})

if(UNIX)
  if(CMAKE_COMPILER_IS_GNUCXX OR CV_ICC)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC")
  endif()
endif()

if(ENABLE_SOLUTION_FOLDERS)
  set_target_properties(${POLOLU_LIBRARY} PROPERTIES FOLDER "3rdparty")
endif()

set_target_properties(${POLOLU_LIBRARY}
  PROPERTIES OUTPUT_NAME ${POLOLU_LIBRARY}
  DEBUG_POSTFIX "${VISP_DEBUG_POSTFIX}"
  COMPILE_PDB_NAME ${POLOLU_LIBRARY}
  COMPILE_PDB_NAME_DEBUG "${POLOLU_LIBRARY}${VISP_DEBUG_POSTFIX}"
  ARCHIVE_OUTPUT_DIRECTORY ${VISP_3P_LIBRARY_OUTPUT_PATH}
  )

if(NOT BUILD_SHARED_LIBS)
  vp_install_target(${POLOLU_LIBRARY} EXPORT VISPModules ARCHIVE DESTINATION ${VISP_3P_LIB_INSTALL_PATH} COMPONENT dev)
endif()

=== 3rdparty/pugixml-1.14/CMakeLists.txt ===
project(${PUGIXML_LIBRARY})

set(PUGIXML_MAJOR_VERSION 1 PARENT_SCOPE)
set(PUGIXML_MINOR_VERSION 14 PARENT_SCOPE)
set(PUGIXML_PATCH_VERSION 0 PARENT_SCOPE)

vp_include_directories(${CMAKE_CURRENT_SOURCE_DIR})

file(GLOB lib_srcs *.cpp)
file(GLOB lib_hdrs *.hpp)

add_library(${PUGIXML_LIBRARY} STATIC ${lib_srcs} ${lib_hdrs})

if(UNIX)
  if(CMAKE_COMPILER_IS_GNUCXX OR CV_ICC)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC")
  endif()
endif()

if(ENABLE_SOLUTION_FOLDERS)
  set_target_properties(${PUGIXML_LIBRARY} PROPERTIES FOLDER "3rdparty")
endif()

set_target_properties(${PUGIXML_LIBRARY}
  PROPERTIES OUTPUT_NAME ${PUGIXML_LIBRARY}
  DEBUG_POSTFIX "${VISP_DEBUG_POSTFIX}"
  COMPILE_PDB_NAME ${PUGIXML_LIBRARY}
  COMPILE_PDB_NAME_DEBUG "${PUGIXML_LIBRARY}${VISP_DEBUG_POSTFIX}"
  ARCHIVE_OUTPUT_DIRECTORY ${VISP_3P_LIBRARY_OUTPUT_PATH}
  )

if(NOT BUILD_SHARED_LIBS)
  vp_install_target(${PUGIXML_LIBRARY} EXPORT VISPModules ARCHIVE DESTINATION ${VISP_3P_LIB_INSTALL_PATH} COMPONENT dev)
endif()

#vp_set_source_file_compile_flag(clipper.cpp -Wno-float-equal)

=== debian/changelog ===
visp (3.7.0-5) unstable; urgency=medium

  * Add patches for visp 3.7.0-5
  * Enable visp namespace
  * Set libvisp-dev Multi-Arch: same

 -- Fabien Spindler <fabien.spindler@inria.fr>  Mon, 09 Feb 2026 14:47:37 +0100

visp (3.7.0-4) unstable; urgency=medium

  * Introduce missing deps to generate doxygen equations in libvisp-doc
  * Comply with Debian architectures baseline enabling only SSE2
  * Introduce more dependencies
  * Introduce installation of ogre-simulator data after reintroducing ogre dep

 -- Fabien Spindler <fabien.spindler@inria.fr>  Fri, 06 Feb 2026 21:21:05 +0100

visp (3.7.0-3) unstable; urgency=medium

  * Update standards-version to 4.7.3
  * Fix redundant globbing patterns in copyright file
  * Update patches for visp 3.7.0 fixing a spelling error
  * Update patches series
  * Fix copyright redundant pattern

 -- Fabien Spindler <fabien.spindler@inria.fr>  Mon, 02 Feb 2026 12:02:00 +0100

visp (3.7.0-2) unstable; urgency=medium

  * Update debian/copyright with last changes
  * Disable java support
  * Rename libvisp-tools package into visp-tools Update installed data to be more explicit
  * Add new patches to improve visp packaging
  * Update installation location since headers are now arch independant
  * Add data specific to intrinsic calibration app

 -- Fabien Spindler <fabien.spindler@inria.fr>  Sun, 01 Feb 2026 14:12:36 +0100

visp (3.7.0-1) unstable; urgency=medium

  * Remove 3.6.0 patches
  * Update copyright to exclude platform folder
  * New upstream version 3.7.0
  * Update debian material for visp 3.7.0
  * Add patches for visp 3.7.0
  * Override lintian very-long-line-length-in-source-file

 -- Fabien Spindler <fabien.spindler@inria.fr>  Fri, 09 Jan 2026 11:16:54 +0100

=== debian/control ===
Source: visp
Maintainer: Fabien Spindler <fabien.spindler@inria.fr>
Uploaders: Olivier Sallou <osallou@debian.org>, Fabien Spindler <Fabien.Spindler@inria.fr>
Section: devel
Priority: optional
Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13),
	cmake,
	doxygen,
	graphviz,
	ghostscript,
	texlive-latex-base,
	texlive-latex-extra,
	texlive-fonts-recommended,
	libcoin-dev,
	libcomedi-dev,
	libdc1394-dev [linux-any],
	libdmtx-dev,
	libeigen3-dev,
	libfreenect-dev,
	libgsl-dev,
	libjpeg-dev,
	liblapack-dev,
	libogre-1.12-dev,
	libois-dev,
	libopenblas-dev,
	libopencv-dev,
	libpcl-dev,
	libpng-dev,
	libv4l-dev [linux-any],
	libx11-dev,
	libxml2-dev,
	libzbar-dev,
	nlohmann-json3-dev,
	visp-images-data (>= 3.6.0)
Standards-Version: 4.7.3
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/science-team/visp
Vcs-Git: https://salsa.debian.org/science-team/visp.git
Homepage: https://visp.inria.fr

Package: libvisp-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends},
	libvisp-ar-dev (= ${binary:Version}),
	libvisp-blob-dev (= ${binary:Version}),
	libvisp-core-dev (= ${binary:Version}),
	libvisp-detection-dev (= ${binary:Version}),
	libvisp-dnn-tracker-dev (= ${binary:Version}),
	libvisp-gui-dev (= ${binary:Version}),
	libvisp-io-dev (= ${binary:Version}),
	libvisp-imgproc-dev (= ${binary:Version}),
	libvisp-klt-dev (= ${binary:Version}),
	libvisp-mbt-dev (= ${binary:Version}),
	libvisp-me-dev (= ${binary:Version}),
	libvisp-robot-dev (= ${binary:Version}),
	libvisp-sensor-dev (= ${binary:Version}),
	libvisp-tt-dev (= ${binary:Version}),
	libvisp-tt-mi-dev (= ${binary:Version}),
	libvisp-visual-features-dev (= ${binary:Version}),
	libvisp-vision-dev (= ${binary:Version}),
	libvisp-vs-dev (= ${binary:Version})
Suggests: libvisp-doc
Description: development files for ViSP
 ViSP (Visual Servoing Platform) is a library for visual tracking
 and visual servoing.
 .
 This package contains the header files and static libraries needed
 to compile applications that use ViSP.
 .
 ViSP standing for Visual Servoing Platform is a modular cross
 platform library that allows prototyping and developing applications
 using visual tracking and visual servoing technics at the heart of the
 researches done by Inria. ViSP is able to compute control
 laws that can be applied to robotic systems. It provides a set of visual
 features that can be tracked using real time image processing or computer
 vision algorithms. ViSP provides also simulation capabilities.
 .
 ViSP can be useful in robotics, computer vision, augmented reality and
 computer animation.

Package: visp-tools
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Visual servoing platform - command-line tools
 ViSP (Visual Servoing Platform) is a library for visual tracking
 and visual servoing.
 .
 This package contains command-line utilities for ViSP including:
  * visp-calibrate-camera: Camera calibration tool
  * visp-compute-apriltag-poses: AprilTag pose computation
  * visp-compute-chessboard-poses: Chessboard pose computation
  * visp-compute-eye-in-hand-calibration: Compute end-effector to camera
    homogeneous transformation in eye-in-hand configuration
  * visp-compute-eye-to-hand-calibration: Compute camera to robot base
    frame homogeneous transformation in eye-to-hand configuration
  * visp-read-rs-dataset: Replay data acquired with a Realsense camera

Package: libvisp-core-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
	libvisp-core3.7t64 (= ${binary:Version}),
	libeigen3-dev,
	libgsl-dev,
	liblapack-dev,
	libopencv-dev,
	libxml2-dev,
	nlohmann-json3-dev
Description: development files for libvisp-core
 This package contains the header files and static library needed to compile
 applications that use ViSP (Visual Servoing Platform) core.
 .
 ViSP standing for Visual Servoing Platform is a modular cross
 platform library that allows prototyping and developing applications
 using visual tracking and visual servoing technics at the heart of the
 researches done by Inria. ViSP is able to compute control
 laws that can be applied to robotic systems. It provides a set of visual
 features that can be tracked using real time image processing or computer
 vision algorithms. ViSP provides also simulation capabilities.
 .
 ViSP can be useful in robotics, computer vision, augmented reality and
 computer animation.

Package: libvisp-core3.7t64
Provides: ${t64:Provides}
Replaces: libvisp-core3.7
Breaks: libvisp-core3.7 (<< ${source:Version})
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: visual servoing platform core library
 This package contains the ViSP (Visual Servoing Platform) core runtime
 libraries.
 .
 ViSP standing for Visual Servoing Platform is a modular cross
 platform library that allows prototyping and developing applications
 using visual tracking and visual servoing technics at the heart of the
 researches done by Inria. ViSP is able to compute control
 laws that can be applied to robotic systems. It provides a set of visual
 features that can be tracked using real time image processing or computer
 vision algorithms. ViSP provides also simulation capabilities.
 .
 ViSP can be useful in robotics, computer vision, augmented reality and
 computer animation.

Package: libvisp-gui-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
	libvisp-core-dev (= ${binary:Version}),
	libvisp-gui3.7t64 (= ${binary:Version}),
	libx11-dev
Description: development files for libvisp-gui
 This package contains the header files and static library needed to compile
 applications that use ViSP (Visual Servoing Platform) graphical user
 interface (GUI) library.
 .
 ViSP standing for Visual Servoing Platform is a modular cross
 platform library that allows prototyping and developing applications
 using visual tracking and visual servoing technics at the heart of the
 researches done by Inria. ViSP is able to compute control
 laws that can be applied to robotic systems. It provides a set of visual
 features that can be tracked using real time image processing or computer
 vision algorithms. ViSP provides also simulation capabilities.
 .
 ViSP can be useful in robotics, computer vision, augmented reality and
 computer animation.

Package: libvisp-gui3.7t64
Provides: ${t64:Provides}
Replaces: libvisp-gui3.7
Breaks: libvisp-gui3.7 (<< ${source:Version})
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
	${shlibs:Depends},
	libvisp-core3.7t64 (= ${binary:Version})
Description: visual servoing platform gui library
 This package contains the ViSP (Visual Servoing Platform) graphical user
 interface (GUI) runtime library.
 .
 ViSP standing for Visual Servoing Platform is a modular cross
 platform library that allows prototyping and developing applications
 using visual tracking and visual servoing technics at the heart of the
 researches done by Inria. ViSP is able to compute control
 laws that can be applied to robotic systems. It provides a set of visual
 features that can be tracked using real time image processing or computer
 vision algorithms. ViSP provides also simulation capabilities.
 .
 ViSP can be useful in robotics, computer vision, augmented reality and
 computer animation.

Package: libvisp-imgproc-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
	libvisp-core-dev (= ${binary:Version}),
	libvisp-imgproc3.7t64 (= ${binary:Version})
Description: development files for libvisp-imgproc
 This package contains the header files and static library needed to compile
 applications that use ViSP (Visual Servoing Platform) image processing
 library.
 .
 ViSP standing for Visual Servoing Platform is a modular cross
 platform library that allows prototyping and developing applications
 using visual tracking and visual servoing technics at the heart of the
 researches done by Inria. ViSP is able to compute control
 laws that can be applied to robotic systems. It provides a set of visual
 features that can be tracked using real time image processing or computer
 vision algorithms. ViSP provides also simulation capabilities.
 .
 ViSP can be useful in robotics, computer vision, augmented reality and
 computer animation.

Package: libvisp-imgproc3.7t64
Provides: ${t64:Provides}
Replaces: libvisp-imgproc3.7
Breaks: libvisp-imgproc3.7 (<< ${source:Version})
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
	${shlibs:Depends},
	libvisp-core3.7t64 (= ${binary:Version})
Description: visual servoing platform imgproc library
 This package contains the ViSP (Visual Servoing Platform) image processing
 runtime library.
 .
 ViSP standing for Visual Servoing Platform is a modular cross
 platform library that allows prototyping and developing applications
 using visual tracking and visual servoing technics at the heart of the
 researches done by Inria. ViSP is able to compute control
 laws that can be applied to robotic systems. It provides a set of visual
 features that can be tracked using real time image processing or computer
 vision algorithms. ViSP provides also simulation capabilities.
 .
 ViSP can be useful in robotics, computer vision, augmented reality and
 computer animation.

Package: libvisp-io-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
	libvisp-core-dev (= ${binary:Version}),
	libvisp-io3.7t64 (= ${binary:Version}),
	libjpeg-dev,
	libopencv-dev,
	libpng-dev,
	nlohmann-json3-dev
Description: development files for libvisp-io
 This package contains the header files and static library needed to compile
 applications that use ViSP (Visual Servoing Platform) input/output
 (io) library.
 .
 ViSP standing for Visual Servoing Platform is a modular cross
 platform library that allows prototyping and developing applications
 using visual tracking and visual servoing technics at the heart of the
 researches done by Inria. ViSP is able to compute control
 laws that can be applied to robotic systems. It provides a set of visual
 features that can be tracked using real time image processing or computer
 vision algorithms. ViSP provides also simulation capabilities.
 .
 ViSP can be useful in robotics, computer vision, augmented reality and
 computer animation.

Package: libvisp-io3.7t64
Provides: ${t64:Provides}
Replaces: libvisp-io3.7
Breaks: libvisp-io3.7 (<< ${source:Version})
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
	${shlibs:Depends},
	libvisp-core3.7t64 (= ${binary:Version})
Description: visual servoing platform io library
 This package contains the ViSP (Visual Servoing Platform) input/output
 (io) runtime library.
 .
 ViSP standing for Visual Servoing Platform is a modular cross
 platform library that allows prototyping and developing applications
 using visual tracking and visual servoing technics at the heart of the
 researches done by Inria. ViSP is able to compute control
 laws that can be applied to robotic systems. It provides a set of visual
 features that can be tracked using real time image processing or computer
 vision algorithms. ViSP provides also simulation capabilities.
 .
 ViSP can be useful in robotics, computer vision, augmented reality and
 computer animation.

Package: libvisp-detection-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
	libvisp-core-dev (= ${binary:Version}),
	libvisp-detection3.7t64 (= ${binary:Version}),
	libdmtx-dev,
	libopencv-dev,
	libzbar-dev
Description: development files for libvisp-detection
 This package contains the header files and static library needed to compile
 applications that use ViSP (Visual Servoing Platform) detection
 library.
 .
 ViSP standing for Visual Servoing Platform is a modular cross
 platform library that allows prototyping and developing applications

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/architecture.mk

# Hardening flags.
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

BUILDDIR = obj-$(DEB_HOST_MULTIARCH)

# Retrieve environment information.
DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_ARCH_OS ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)

# Linux-specific stuff (dc1394, v4l, ois only available on linux)
ifeq ($(DEB_HOST_ARCH_OS),linux)
  CMAKE_ARCH_FLAGS = -DUSE_DC1394=ON -DUSE_V4L2=ON -DUSE_OIS=ON
else
  CMAKE_ARCH_FLAGS = -DUSE_DC1394=OFF -DUSE_V4L2=OFF -DUSE_OIS=OFF
endif

# Comply with Debian architectures baseline
# https://wiki.debian.org/ArchitectureSpecificsMemo#Architecture_baselines
# Enable only SSE2 since SSE3 is not guaranteed
CMAKE_ARCH_FLAGS += -DENABLE_SSE2=ON
CMAKE_ARCH_FLAGS += -DENABLE_SSE3=OFF
CMAKE_ARCH_FLAGS += -DENABLE_SSSE3=OFF

# On armel, since 3.4.0-3 build returns the following error
# "ABORT: Received TERM signal"
# Disable parallel build (make -j1) to reduce memory usage
ifeq ($(DEB_HOST_ARCH_OS),armel)
  export DEB_BUILD_MAINT_OPTIONS="parallel=1"
endif

# CMake flags
CMAKE_FLAGS = \
	-DCMAKE_INSTALL_PREFIX=/usr \
	-DCMAKE_VERBOSE_MAKEFILE=ON \
	-DCMAKE_C_FLAGS_RELEASE="$(CFLAGS)" \
	-DCMAKE_CXX_FLAGS_RELEASE="$(CXXFLAGS)" \
	-DCMAKE_SHARED_LINKER_FLAGS_RELEASE="$(LDFLAGS)" \
	-DCMAKE_EXE_LINKER_FLAGS_RELEASE="$(LDFLAGS)" \
	-DCMAKE_INSTALL_LIBDIR="lib" \
	-DCMAKE_BUILD_TYPE=Release \
	-DCMAKE_SKIP_RPATH=ON \
	-DENABLE_MULTIARCH=ON \
	-DENABLE_VISP_NAMESPACE=ON \
	-DUSE_SOQT=OFF \
	-DBUILD_JAVA=OFF \
	$(CMAKE_ARCH_FLAGS)

%:
	dh $@ --buildsystem=cmake

override_dh_clean:
	dh_clean -O--buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_FLAGS)

override_dh_auto_build-indep:
	dh_auto_build -- visp_doc # Generate Doxygen HTML documentation.

override_dh_installdocs:
	dh_installdocs -X.md5

# Due to numerical imprecision, some tests are failing on ia64.
# This is not a critical issue so we let the testing fail on this
# architecture for now.
# See http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=723803
ifeq ($(DEB_HOST_ARCH),ia64)
  DH_AUTOTEST_CAN_FAIL=true
else
  DH_AUTOTEST_CAN_FAIL=false
endif

override_dh_auto_test-indep:

override_dh_auto_test-arch:
	-LD_LIBRARY_PATH=$(shell realpath $(BUILDDIR))/lib dh_auto_test || ${DH_AUTOTEST_CAN_FAIL}
